## qt6-grpc 6.8.2

=== src/grpc/CMakeLists.txt ===
# Copyright (C) 2022 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

qt_internal_add_module(Grpc
    SOURCES
        qgrpcoperation.h qgrpcoperation.cpp
        qgrpcoperationcontext.h qgrpcoperationcontext.cpp
        qgrpccallreply.h qgrpccallreply.cpp
        qgrpcstream.h qgrpcstream.cpp
        qgrpcstatus.h qgrpcstatus.cpp
        qabstractgrpcchannel.h qabstractgrpcchannel_p.h qabstractgrpcchannel.cpp
        qgrpchttp2channel.h qgrpchttp2channel.cpp
        qgrpcclientbase.h qgrpcclientbase.cpp
        qgrpccalloptions.h qgrpccalloptions.cpp
        qgrpcchanneloptions.h qgrpcchanneloptions.cpp
        qtgrpcglobal.h
        qtgrpclogging_p.h qtgrpclogging.cpp
        qtgrpcnamespace.h
        qgrpcserializationformat.h qgrpcserializationformat.cpp
    LIBRARIES
        Qt::CorePrivate
        Qt::NetworkPrivate
    PUBLIC_LIBRARIES
        Qt::Core
        Qt::Protobuf
        Qt::Network
    QT_LICENSE_ID QT_COMMERCIAL_OR_GPL3
)

qt_internal_add_docs(Grpc
    doc/qtgrpc.qdocconf
)

# TODO: Remove this and fix it in qtbase's qt_internal_find_tool directly
if(QT_HOST_PATH AND Qt6::qtgrpcgen IN_LIST Qt6GrpcTools_TARGETS AND NOT QT_FORCE_BUILD_TOOLS)
    qt_record_extra_qt_main_tools_package_dependency(Grpc GrpcTools "${PROJECT_VERSION}")
endif()

=== src/protobuf/CMakeLists.txt ===
# Copyright (C) 2022 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

qt_internal_add_module(Protobuf
    SOURCES
        protobuffieldpresencechecker_p.h
        protobufscalarserializers_p.h protobufscalarserializers_p.cpp
        protobufscalarjsonserializers_p.h
        qtprotobufglobal.h
        qabstractprotobufserializer.cpp qabstractprotobufserializer.h
        qprotobufdeserializerbase_p.h qprotobufdeserializerbase.cpp
        qprotobufjsonserializer.cpp qprotobufjsonserializer.h
        qprotobuflazymessagepointer.h
        qprotobufmessage.cpp qprotobufmessage.h qprotobufmessage_p.h
        qprotobufobject.h
        qprotobufoneof.cpp qprotobufoneof.h
        qprotobufpropertyordering.cpp qprotobufpropertyordering.h
        qprotobufpropertyorderingbuilder_p.h
        qprotobufregistration.cpp qprotobufregistration.h qprotobufregistration_p.h
        qprotobufrepeatediterator.cpp qprotobufrepeatediterator.h
        qprotobufselfcheckiterator_p.h
        qprotobufserializer.cpp qprotobufserializer.h qprotobufserializer_p.h
        qtprotobufdefs_p.h
        qtprotobuflogging.cpp qtprotobuflogging_p.h
        qtprotobufserializerhelpers.cpp qtprotobufserializerhelpers_p.h
        qtprotobuftypes.cpp qtprotobuftypes.h
        qprotobufserializerbase_p.h qprotobufserializerbase.cpp
    EXTRA_CMAKE_FILES
        "${CMAKE_CURRENT_SOURCE_DIR}/QtProtobufProperties.cmake.in"
    PUBLIC_LIBRARIES
        Qt::Core
    LIBRARIES
        Qt::CorePrivate
    PRIVATE_MODULE_INTERFACE
        Qt::CorePrivate
)

qt_internal_add_docs(Protobuf
    doc/qtprotobuf.qdocconf
)

# Suppress 'No relevant classes found. No output generated.' warning
set_source_files_properties(qprotobufobject.h PROPERTIES SKIP_AUTOMOC ON)

if(CMAKE_VERSION GREATER_EQUAL 3.27)
    set_target_properties(Protobuf PROPERTIES INTERFACE_AUTOMOC_MACRO_NAMES "Q_PROTOBUF_OBJECT")
endif()

# TODO: Remove this and fix it in qtbase's qt_internal_find_tool directly
if(QT_HOST_PATH AND Qt6::qtprotobufgen IN_LIST Qt6ProtobufTools_TARGETS
    AND NOT QT_FORCE_BUILD_TOOLS)
    qt_record_extra_qt_main_tools_package_dependency(Protobuf ProtobufTools "${PROJECT_VERSION}")
endif()

=== src/wellknown/CMakeLists.txt ===
# Copyright (C) 2022 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

qt_internal_add_protobuf_module(ProtobufWellKnownTypes
    SOURCES
        qtprotobufwellknowntypesglobal.h
        qprotobufanysupport.cpp qprotobufanysupport.h
    PUBLIC_LIBRARIES
        Qt::Protobuf
    LIBRARIES
        Qt::ProtobufPrivate
)

qt_internal_add_protobuf_wellknown_types(ProtobufWellKnownTypes
    any
    api
    duration
    empty
    field_mask
    source_context
    struct
    timestamp
    type
    wrappers
)

=== examples/grpc/magic8ball/CMakeLists.txt ===
# Copyright (C) 2023 The Qt Company Ltd.
# SPDX-License-Identifier: LicenseRef-Qt-Commercial OR BSD-3-Clause

cmake_minimum_required(VERSION 3.16)
project(Magic8Ball LANGUAGES CXX)

if(NOT DEFINED INSTALL_EXAMPLESDIR)
    set(INSTALL_EXAMPLESDIR "examples")
endif()

set(INSTALL_EXAMPLEDIR "${INSTALL_EXAMPLESDIR}/grpc/magic8ball")

find_package(Qt6 REQUIRED COMPONENTS
    Core
    Protobuf
    ProtobufQuick
    Grpc
    GrpcQuick
    GrpcTools
    Quick
)

qt_standard_project_setup()

qt_add_executable(magic8ball
    main.cpp
)

qt_add_protobuf(magic8ball_plugin
    PROTO_FILES
        proto/exampleservice.proto
    QML
)

qt_add_grpc(magic8ball_plugin CLIENT
    PROTO_FILES
        proto/exampleservice.proto
    QML
)

set_target_properties(magic8ball PROPERTIES
    WIN32_EXECUTABLE TRUE
    MACOSX_BUNDLE TRUE
)

qt_add_qml_module(magic8ball
    URI qtgrpc.examples.magic8ball
    VERSION 1.0
    RESOURCE_PREFIX "/qt/qml"
    QML_FILES
        "AnimatedAnswer.qml"
        "MagicText.qml"
        "MagicBall.qml"
        "Main.qml"
        "ScaleAnimation.qml"
)

target_link_libraries(magic8ball PRIVATE
    Qt6::Core
    Qt6::Quick
    Qt6::Protobuf
    Qt6::Grpc
    Qt6::GrpcQuick
    magic8ball_plugin
)

install(TARGETS magic8ball
    RUNTIME DESTINATION "${INSTALL_EXAMPLEDIR}"
    BUNDLE DESTINATION "${INSTALL_EXAMPLEDIR}"
    LIBRARY DESTINATION "${INSTALL_EXAMPLEDIR}"
)

add_subdirectory(server)
if(TARGET magic8ball_server)
    add_dependencies(magic8ball magic8ball_server)
endif()

=== examples/grpc/vehicle/CMakeLists.txt ===
# Copyright (C) 2024 The Qt Company Ltd.
# SPDX-License-Identifier: LicenseRef-Qt-Commercial OR BSD-3-Clause

cmake_minimum_required(VERSION 3.16)
project(vehicle LANGUAGES CXX)

if(NOT DEFINED INSTALL_EXAMPLESDIR)
    set(INSTALL_EXAMPLESDIR "examples")
endif()

set(INSTALL_EXAMPLEDIR "${INSTALL_EXAMPLESDIR}/grpc/vehicle")

find_package(Qt6 REQUIRED COMPONENTS
    Core
    Protobuf
    ProtobufWellKnownTypes
    Grpc
    Quick
)

qt_standard_project_setup()

qt_add_executable(vehicle_client
    main.cpp
    vehiclemanager.h
    vehiclemanager.cpp
    vehiclethread.h
    vehiclethread.cpp
    navigationthread.h
    navigationthread.cpp
)

qt_add_protobuf(vehiclelib
    PROTO_FILES
        proto/vehicleservice.proto
        proto/navigationservice.proto
)

qt_add_grpc(vehiclelib CLIENT
    PROTO_FILES
        proto/vehicleservice.proto
        proto/navigationservice.proto
)

target_link_libraries(vehiclelib PRIVATE Qt6::ProtobufWellKnownTypes)

set_target_properties(vehicle_client PROPERTIES
    WIN32_EXECUTABLE TRUE
    MACOSX_BUNDLE TRUE
)

qt_add_qml_module(vehicle_client
    URI qtgrpc.examples.vehicle
    VERSION 1.0
    RESOURCE_PREFIX "/qt/qml"
    QML_FILES
        "StyledText.qml"
        "StyledProgressBar.qml"
        "Main.qml"
)

qt_add_resources(vehicle_client
    "resources"
    PREFIX "/"
    BASE "resources"
    FILES
        "resources/direction_left.svg"
        "resources/direction_right.svg"
        "resources/direction_straight.svg"
        "resources/fuel_icon.svg"
)

target_link_libraries(vehicle_client PRIVATE
    Qt6::Core
    Qt6::Quick
    Qt6::Protobuf
    Qt6::ProtobufWellKnownTypes
    Qt6::Grpc
    vehiclelib
)

install(TARGETS vehicle_client vehiclelib
    RUNTIME DESTINATION "${INSTALL_EXAMPLEDIR}"
    BUNDLE DESTINATION "${INSTALL_EXAMPLEDIR}"
    LIBRARY DESTINATION "${INSTALL_EXAMPLEDIR}"
)

add_subdirectory(server)
if(TARGET vehicle_server)
    add_dependencies(vehicle_client vehicle_server)
endif()

=== src/tools/qtprotobufgen/CMakeLists.txt ===
# Copyright (C) 2022 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

qt_get_tool_target_name(target_name qtprotobufgen)
qt_internal_add_tool(${target_name}
    TARGET_DESCRIPTION "Qt Protobuf generator"
    INSTALL_DIR "${INSTALL_LIBEXECDIR}"
    TOOLS_TARGET Protobuf
    CORE_LIBRARY None
    EXCEPTIONS
    SOURCES
        main.cpp
        qprotobufgenerator.cpp qprotobufgenerator.h
        messagedeclarationprinter.cpp messagedeclarationprinter.h
        messagedefinitionprinter.cpp messagedefinitionprinter.h
        enumdeclarationprinter.cpp enumdeclarationprinter.h
        enumdefinitionprinter.cpp enumdefinitionprinter.h
    EXTRA_CMAKE_FILES
        "${CMAKE_CURRENT_SOURCE_DIR}/${QT_CMAKE_EXPORT_NAMESPACE}ProtobufToolsMacros.cmake"
        "${CMAKE_CURRENT_SOURCE_DIR}/QtProtocCommandWrapper.cmake"
    EXTRA_CMAKE_INCLUDES
        "${QT_CMAKE_EXPORT_NAMESPACE}ProtobufToolsMacros.cmake"
    LIBRARIES
        WrapProtobuf::WrapLibProtobuf
        WrapProtobuf::WrapLibProtoc
        QtProtocCommon
    ATTRIBUTION_FILE_DIR_PATHS
        ../../../
    ATTRIBUTION_ENTRY_INDEX 0
)

qt_internal_return_unless_building_tools()

qt_record_extra_package_dependency(${target_name} WrapProtoc "")

if(MSVC)
    # Disable C4251:
    # `class 'type1' needs to have dll-interface to be used by clients of class 'type2'`
    # which can be generated from some of the protobuf headers on msvc.
    # This warning is also disabled globally in Qt in QtCore/qcompilerdetection.h
    target_compile_options(${target_name}
        PRIVATE "/wd4251"
    )
    target_compile_definitions(${target_name}
        PRIVATE "_SILENCE_CXX17_ITERATOR_BASE_CLASS_DEPRECATION_WARNING"
    )
endif()

=== examples/grpc/vehicle/server/CMakeLists.txt ===
# Copyright (C) 2024 The Qt Company Ltd.
# SPDX-License-Identifier: LicenseRef-Qt-Commercial OR BSD-3-Clause

cmake_minimum_required(VERSION 3.16)
project(VehicleServer LANGUAGES CXX)

set(CMAKE_FIND_PACKAGE_PREFER_CONFIG TRUE)

find_package(WrapProtoc)
find_package(WrapgRPC)
find_package(WrapgRPCPlugin)

if(NOT TARGET WrapProtoc::WrapProtoc OR NOT TARGET WrapgRPC::WrapLibgRPC
    OR NOT TARGET WrapgRPC::WrapgRPCPlugin)
    message(WARNING "Dependencies of VehicleServer not found. Skipping.")
    return()
endif()

if(MINGW)
    message(WARNING "${PROJECT_NAME} uses reference grpc++ library that doesn't officially support"
        " MinGW. Please use the MSVC compiler to build this example. The correct work is not"
        " guaranteed otherwise.")
endif()

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

set(proto_files
    "${CMAKE_CURRENT_LIST_DIR}/../proto/vehicleservice.proto"
    "${CMAKE_CURRENT_LIST_DIR}/../proto/navigationservice.proto")
set(out_dir ${CMAKE_CURRENT_BINARY_DIR})

set(generated_files
    "${out_dir}/vehicleservice.pb.h" "${out_dir}/vehicleservice.pb.cc"
    "${out_dir}/vehicleservice.grpc.pb.h" "${out_dir}/vehicleservice.grpc.pb.cc"
    "${out_dir}/navigationservice.pb.h" "${out_dir}/navigationservice.pb.cc"
    "${out_dir}/navigationservice.grpc.pb.h" "${out_dir}/navigationservice.grpc.pb.cc")

add_custom_command(
    OUTPUT ${generated_files}
    COMMAND
    $<TARGET_FILE:WrapProtoc::WrapProtoc>
    ARGS
    --grpc_out "${out_dir}"
    --cpp_out "${out_dir}"
    -I "${CMAKE_CURRENT_LIST_DIR}/../proto/"
    --plugin=protoc-gen-grpc=$<TARGET_FILE:WrapgRPC::WrapgRPCPlugin>
    "${proto_files}"
    WORKING_DIRECTORY ${out_dir}
    DEPENDS "${proto_files}"
    COMMENT "Generating gRPC ${target} sources..."
    COMMAND_EXPAND_LISTS
    VERBATIM
)

set_source_files_properties(${generated_files} PROPERTIES GENERATED TRUE)

qt_add_executable(vehicle_server
    ${generated_files}
    ${CMAKE_CURRENT_LIST_DIR}/main.cpp
)

target_include_directories(vehicle_server
    PRIVATE
    ${out_dir}
)

target_link_libraries(vehicle_server
    PRIVATE
    WrapgRPC::WrapLibgRPC
)

install(TARGETS vehicle_server
    RUNTIME DESTINATION "${INSTALL_EXAMPLEDIR}"
    BUNDLE DESTINATION "${INSTALL_EXAMPLEDIR}"
    LIBRARY DESTINATION "${INSTALL_EXAMPLEDIR}"
)

=== tests/auto/protobufqml/nested/CMakeLists.txt ===
# Copyright (C) 2023 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

if(NOT QT_BUILD_STANDALONE_TESTS AND NOT QT_BUILDING_QT)
    cmake_minimum_required(VERSION 3.16)
    project(tst_protobuf_nested_qml LANGUAGES CXX)
    find_package(Qt6BuildInternals REQUIRED COMPONENTS STANDALONE_TEST)
endif()

qt_policy(SET QTP0001 NEW)
qt_policy(SET QTP0004 NEW)

qt_internal_add_test(tst_nestedtypes_qtprotobuf_qmltest
    QMLTEST
    SOURCES
        tst_protobuf_nested_qml.cpp
    LIBRARIES
        Qt::Qml
)

qt_add_protobuf(tst_nestedtypes_qtprotobuf_qml
    PROTO_FILES
        ../../protobuf/nested/proto/nestedmessages.proto
        ../../protobuf/nested/proto/externalpackage.proto
    QML
    QML_URI
        qtprotobufnamespace.tests.nested
    OUTPUT_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/qt_protobuf_generated"
)

qt_add_qml_module(tst_nestedtypes_qtprotobuf_qmltest
    URI QmlTestUri
    VERSION 1.0
    QML_FILES
        qml/tst_nested.qml
)

qt_autogen_tools_initial_setup(tst_nestedtypes_qtprotobuf_qmltest)
qt_autogen_tools_initial_setup(tst_nestedtypes_qtprotobuf_qml)
qt_autogen_tools_initial_setup(tst_nestedtypes_qtprotobuf_qmlplugin)

qt_add_protobuf(tst_externalpackage_qtprotobuf_qml
    PROTO_FILES
        ../../protobuf/nested/proto/externalpackage.proto
    QML
    OUTPUT_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/qt_protobuf_externalpackage_generated"
)

qt_autogen_tools_initial_setup(tst_externalpackage_qtprotobuf_qml)
qt_autogen_tools_initial_setup(tst_externalpackage_qtprotobuf_qmlplugin)

if(QT_BUILD_STANDALONE_TESTS)
    qt_import_qml_plugins(tst_nestedtypes_qtprotobuf_qmltest)
    qt_import_qml_plugins(tst_nestedtypes_qtprotobuf_qml)
    qt_import_qml_plugins(tst_externalpackage_qtprotobuf_qml)
endif()

=== tests/manual/grpc/benchmarks/asyncbenchserver/CMakeLists.txt ===
# Copyright (C) 2024 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

set(CMAKE_CXX_STANDARD 20)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

find_package(WrapgRPCPlugin)
find_package(WrapProtobuf)
find_package(WrapgRPC)

if(NOT WrapgRPCPlugin_FOUND OR NOT WrapProtobuf_FOUND OR NOT WrapgRPC_FOUND)
    message(WARNING "Dependencies of QtGrpc benchmark-server not found. Skipping.")
    return()
endif()

set(proto_out_dir "${CMAKE_CURRENT_BINARY_DIR}/include/proto/")
set(proto_out_include "${CMAKE_CURRENT_BINARY_DIR}/include/")

set(generated_files
    "${proto_out_dir}/bench.grpc.pb.h"
    "${proto_out_dir}/bench.grpc.pb.cc"
    "${proto_out_dir}/bench.pb.h"
    "${proto_out_dir}/bench.pb.cc"
)

set(extra_protoc_args "")
get_target_property(protoc_version WrapProtoc::WrapProtoc _qt_internal_protobuf_version)
if(protoc_version VERSION_GREATER_EQUAL "3.12" AND protoc_version VERSION_LESS "3.15")
    list(APPEND extra_protoc_args "--experimental_allow_proto3_optional")
endif()

add_custom_command(
    OUTPUT ${generated_files}
    COMMAND
        $<TARGET_FILE:WrapProtoc::WrapProtoc>
    ARGS
        "${extra_protoc_args}"
        --grpc_out "${proto_out_dir}"
        --cpp_out "${proto_out_dir}"
        -I "${proto_include}"
        --plugin=protoc-gen-grpc=$<TARGET_FILE:WrapgRPC::WrapgRPCPlugin>
        "${proto_path}"
    WORKING_DIRECTORY "${proto_out_dir}"
    DEPENDS
        "${proto_path}"
        $<TARGET_FILE:WrapProtoc::WrapProtoc>
        $<TARGET_FILE:WrapgRPC::WrapgRPCPlugin>
    COMMENT "Generating gRPC ${target} sources..."
    COMMAND_EXPAND_LISTS
    VERBATIM
)

set_source_files_properties(${generated_files} PROPERTIES GENERATED TRUE)

qt_internal_add_executable(
    asyncbenchserver
    SOURCES
        asyncbenchserver.cpp
        "${generated_files}"
    LIBRARIES
        WrapProtobuf::WrapLibProtobuf
        WrapgRPC::WrapLibgRPC
    INCLUDE_DIRECTORIES
        "${proto_out_include}"
        "${qrpcbench_common_include}"
    OUTPUT_DIRECTORY
        "${CMAKE_CURRENT_BINARY_DIR}"
)

=== tests/auto/grpc/client/shared/test_server_go/CMakeLists.txt ===
# Copyright (C) 2023 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

find_package(WrapProtobuf)

if(NOT WrapProtobuf_FOUND)
    message(WARNING "Dependencies of Qt GRPC test server not found. Skipping.")
    return()
endif()


set(go_packages
    "google.golang.org/protobuf/cmd/protoc-gen-go@latest"
    "google.golang.org/grpc/cmd/protoc-gen-go-grpc@latest"
)

set(go_path ${CMAKE_CURRENT_BINARY_DIR}/go)
foreach(package ${go_packages})
    execute_process(COMMAND ${CMAKE_COMMAND} -E env GOPATH=${go_path} -- go install ${package})
endforeach()

set(server_sources main.go)
set(server_sources_copied ${server_sources})
list(TRANSFORM server_sources PREPEND "${CMAKE_CURRENT_SOURCE_DIR}/")
list(TRANSFORM server_sources_copied PREPEND "${CMAKE_CURRENT_BINARY_DIR}/")

set(testserver_gen_output
    "${CMAKE_CURRENT_BINARY_DIR}/qtgrpc/tests/testservice_grpc.pb.go"
    "${CMAKE_CURRENT_BINARY_DIR}/qtgrpc/tests/testservice.pb.go"
)

set(extra_protoc_args "")
get_target_property(protoc_version WrapProtoc::WrapProtoc _qt_internal_protobuf_version)
if(protoc_version VERSION_GREATER_EQUAL "3.12" AND protoc_version VERSION_LESS "3.15")
    list(APPEND extra_protoc_args "--experimental_allow_proto3_optional")
endif()

add_custom_command(
    OUTPUT
        ${testserver_gen_output}
    COMMAND
        ${CMAKE_COMMAND} -E env "PATH=$ENV{PATH}:${go_path}/bin" "GOPATH=${go_path}" --
        $<TARGET_FILE:WrapProtoc::WrapProtoc>
        ${extra_protoc_args}
        --go_out=${CMAKE_CURRENT_BINARY_DIR}
        --go-grpc_out=${CMAKE_CURRENT_BINARY_DIR}
        -I${CMAKE_CURRENT_LIST_DIR}/../../../shared/proto
        ${CMAKE_CURRENT_LIST_DIR}/../../../shared/proto/testservice.proto
    DEPENDS
        ${CMAKE_CURRENT_LIST_DIR}/../../../shared/proto/testservice.proto
    VERBATIM
)

set(testserver_gen_module_output
    "${CMAKE_CURRENT_BINARY_DIR}/qtgrpc/tests/go.mod"
    "${CMAKE_CURRENT_BINARY_DIR}/qtgrpc/tests/go.sum"
)
add_custom_command(
    OUTPUT
        ${testserver_gen_module_output}
    COMMAND
        ${CMAKE_COMMAND} -E remove "${CMAKE_CURRENT_BINARY_DIR}/qtgrpc/tests/go.mod"
    COMMAND
        ${CMAKE_COMMAND} -E env "GOPATH=${go_path}" -- ${go} mod init qtgrpc/tests
    COMMAND
        ${CMAKE_COMMAND} -E env "GOPATH=${go_path}" -- ${go} mod tidy
    DEPENDS
        ${testserver_gen_output}
    WORKING_DIRECTORY
        "${CMAKE_CURRENT_BINARY_DIR}/qtgrpc/tests"
    VERBATIM
)

add_custom_command(
    OUTPUT
        ${server_sources_copied}
    COMMAND
        ${CMAKE_COMMAND} -E copy_if_different ${server_sources} "${CMAKE_CURRENT_BINARY_DIR}"
    DEPENDS
        ${server_sources}
    VERBATIM
)

set(testserver_module_init_output
    "${CMAKE_CURRENT_BINARY_DIR}/go.mod"
    "${CMAKE_CURRENT_BINARY_DIR}/go.sum"
)
add_custom_command(
    OUTPUT
        ${testserver_module_init_output}
    COMMAND
        ${CMAKE_COMMAND} -E remove "${CMAKE_CURRENT_BINARY_DIR}/go.mod"
    COMMAND
        ${CMAKE_COMMAND} -E env "GOPATH=${go_path}" -- ${go} mod init grpc_testserver
    COMMAND
        ${CMAKE_COMMAND} -E env "GOPATH=${go_path}" -- ${go} mod edit -replace qtgrpc/tests=./qtgrpc/tests
    COMMAND
        ${CMAKE_COMMAND} -E env "GOPATH=${go_path}" -- ${go} mod tidy
    DEPENDS
        ${testserver_gen_module_output}
        ${server_sources_copied}
    VERBATIM
)


set(testserver_timestamp "${CMAKE_CURRENT_BINARY_DIR}/grpc_testserver_timestamp")
add_custom_command(
    OUTPUT "${testserver_timestamp}"
    COMMAND
        ${CMAKE_COMMAND} -E env "GOPATH=${go_path}" -- ${go} get
    COMMAND
        ${CMAKE_COMMAND} -E env "GOPATH=${go_path}" -- ${go} build
    COMMAND
        ${CMAKE_COMMAND} -E touch "${testserver_timestamp}"
    DEPENDS
        ${server_sources}
        ${testserver_module_init_output}
    VERBATIM
)

set(server_certs
    "${CMAKE_CURRENT_LIST_DIR}/../test_server/assets/cert.pem"
    "${CMAKE_CURRENT_LIST_DIR}/../test_server/assets/key.pem"
)

set(server_certs_output
    "${CMAKE_CURRENT_BINARY_DIR}/cert.pem"
    "${CMAKE_CURRENT_BINARY_DIR}/key.pem"
)

add_custom_command(
    OUTPUT ${server_certs_output}
    COMMAND
        ${CMAKE_COMMAND} -E copy_if_different ${server_certs} "${CMAKE_CURRENT_BINARY_DIR}"
    DEPENDS
        ${server_certs}
    VERBATIM
)

add_custom_target(grpc_testserver_build ALL DEPENDS
    ${testserver_timestamp}
    ${server_certs_output}
)

add_executable(grpc_testserver IMPORTED)
add_dependencies(grpc_testserver grpc_testserver_build)
set_target_properties(grpc_testserver PROPERTIES
    IMPORTED_LOCATION
        "${CMAKE_CURRENT_BINARY_DIR}/grpc_testserver"
    IMPORTED_GLOBAL TRUE
)

=== debian/changelog ===
qt6-grpc (6.8.2-3) unstable; urgency=medium

  * Upload to unstable.

 -- Patrick Franz <deltaone@debian.org>  Sat, 01 Mar 2025 12:37:46 +0100

qt6-grpc (6.8.2-2) experimental; urgency=medium

  [ Patrick Franz ]
  * Update list of installed files.
  * Update symbols from buildlogs.

 -- Patrick Franz <deltaone@debian.org>  Thu, 13 Feb 2025 21:38:45 +0100

qt6-grpc (6.8.2-1) experimental; urgency=medium

  [ Patrick Franz ]
  * New upstream release (6.8.2).
  * Bump Qt B-Ds to 6.8.2.
  * New binary packages and update list of installed files.
  * Update symbols from buildlogs.
  * Update d/copyright.

 -- Patrick Franz <deltaone@debian.org>  Sat, 08 Feb 2025 00:50:41 +0100

=== debian/control ===
Source: qt6-grpc
Section: libs
Priority: optional
Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
Uploaders: Patrick Franz <deltaone@debian.org>,
Build-Depends: cmake (>= 3.24~),
               debhelper-compat (= 13),
               dh-sequence-qmldeps,
               dh-sequence-pkgkde-symbolshelper,
               libgrpc++-dev,
               libprotobuf-c-dev,
               libprotobuf-dev,
               libprotoc-dev,
               ninja-build,
               pkg-kde-tools,
               pkgconf,
               protobuf-compiler-grpc,
               qt6-base-dev (>= 6.8.2+dfsg~),
               qt6-base-private-dev (>= 6.8.2+dfsg~),
               qt6-declarative-dev (>= 6.8.2+dfsg~),
               qt6-declarative-private-dev (>= 6.8.2+dfsg~),
Build-Depends-Indep: qt6-base-dev (>= 6.8~) <!nodoc>,
                     qt6-documentation-tools (>= 6.8~) <!nodoc>,
Standards-Version: 4.7.0
Homepage: https://www.qt.io/developers/
Vcs-Browser: https://salsa.debian.org/qt-kde-team/qt6/qt6-grpc
Vcs-Git: https://salsa.debian.org/qt-kde-team/qt6/qt6-grpc.git
Rules-Requires-Root: no

Package: libqt6grpc6
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends},
Depends: ${misc:Depends}, ${shlibs:Depends},
Description: Qt 6 gRPC library
 Qt is a cross-platform C++ application framework. Qt's primary feature
 is its rich set of widgets that provide standard GUI functionality.
 .
 This package contains the library for Qt 6 gRPC.

Package: libqt6grpcquick6
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends},
Depends: ${misc:Depends}, ${shlibs:Depends},
Description: Qt 6 gRPC Quick library
 Qt is a cross-platform C++ application framework. Qt's primary feature
 is its rich set of widgets that provide standard GUI functionality.
 .
 This package contains the library for Qt 6 gRPC Quick.

Package: libqt6protobuf6
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends},
Depends: ${misc:Depends}, ${shlibs:Depends},
Description: Qt 6 protocol buffers library
 Qt is a cross-platform C++ application framework. Qt's primary feature
 is its rich set of widgets that provide standard GUI functionality.
 .
 This package contains the library for Qt 6 protocol buffers.

Package: libqt6protobufqtcoretypes6
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends},
Depends: ${misc:Depends}, ${shlibs:Depends},
Description: Qt 6 protocol buffers Qt Core types library
 Qt is a cross-platform C++ application framework. Qt's primary feature
 is its rich set of widgets that provide standard GUI functionality.
 .
 This package contains the library for Qt 6 protocol buffers Qt Core types.

Package: libqt6protobufqtguitypes6
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends},
Depends: ${misc:Depends}, ${shlibs:Depends},
Description: Qt 6 procotol buffers Qt GUI types library
 Qt is a cross-platform C++ application framework. Qt's primary feature
 is its rich set of widgets that provide standard GUI functionality.
 .
 This package contains the library for Qt 6 protocol buffers Qt GUI types.

Package: libqt6protobufquick6
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends},
Depends: ${misc:Depends}, ${shlibs:Depends},
Description: Qt 6 protocol buffers QML library
 Qt is a cross-platform C++ application framework. Qt's primary feature
 is its rich set of widgets that provide standard GUI functionality.
 .
 This package contains the QML library for Qt 6 protocol buffers.

Package: libqt6protobufwellknowntypes6
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends},
Depends: ${misc:Depends}, ${shlibs:Depends},
Description: Qt 6 gRPC protocol buffers Well Known types library
 Qt is a cross-platform C++ application framework. Qt's primary feature
 is its rich set of widgets that provide standard GUI functionality.
 .
 This package contains the library for Qt 6 protocol buffer Well Known types.

Package: qml6-module-qtgrpc
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends},
Depends: ${misc:Depends}, ${qml6:Depends}, ${shlibs:Depends},
Description: Qt 6 gRPC QML module
 Qt is a cross-platform C++ application framework. Qt's primary feature
 is its rich set of widgets that provide standard GUI functionality.
 .
 This package contains the QML module for Qt gRPC.

Package: qml6-module-qtprotobuf
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends},
Depends: ${misc:Depends}, ${qml6:Depends}, ${shlibs:Depends},
Description: Qt 6 protocol buffers QML module
 Qt is a cross-platform C++ application framework. Qt's primary feature
 is its rich set of widgets that provide standard GUI functionality.
 .
 This package contains the QML module for Qt protocol buffers.

Package: qt6-grpc-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libqt6grpc6 (= ${binary:Version}),
         libqt6grpcquick6 (= ${binary:Version}),
         libqt6protobuf6 (= ${binary:Version}),
         libqt6protobufqtcoretypes6 (= ${binary:Version}),
         libqt6protobufqtguitypes6 (= ${binary:Version}),
         libqt6protobufquick6 (= ${binary:Version}),
         libqt6protobufwellknowntypes6 (= ${binary:Version}),
         qml6-module-qtgrpc (= ${binary:Version}),
         qml6-module-qtprotobuf (= ${binary:Version}),
         qt6-base-dev,
         qt6-grpc-tools (= ${binary:Version}),
         ${misc:Depends},
Description: Qt 6 gRPC development files
 Qt is a cross-platform C++ application framework. Qt's primary feature
 is its rich set of widgets that provide standard GUI functionality.
 .
 This package contains the development headers for the gRPC library.

Package: qt6-grpc-tools
Section: libdevel
Architecture: any
Multi-Arch: foreign
Depends: libqt6grpc6 (= ${binary:Version}),
         libqt6protobuf6 (= ${binary:Version}),
         qt6-base-dev,
         ${misc:Depends},
         ${shlibs:Depends},
Description: Qt 6 gRPC tools
 Qt is a cross-platform C++ application framework. Qt's primary feature
 is its rich set of widgets that provide standard GUI functionality.
 .
 This package contains binaries required for gRPC/protobuf generation.

Package: qt6-grpc-doc
Architecture: all
Section: doc
Depends: qt6-base-doc, ${misc:Depends},
Multi-Arch: foreign
Description: Qt 6 gRPC documentation
 Qt is a cross-platform C++ application framework. Qt's primary feature
 is its rich set of widgets that provide standard GUI functionality.
 .
 This package contains the documentation for the Qt 6 gRPC.

Package: qt6-grpc-doc-html
Architecture: all
Section: doc
Depends: qt6-base-doc-html, ${misc:Depends},
Multi-Arch: foreign
Description: Qt 6 gRPC HTML documentation
 Qt is a cross-platform C++ application framework. Qt's primary feature
 is its rich set of widgets that provide standard GUI functionality.
 .
 This package contains the HTML documentation for the Qt 6 gRPC.

Package: qt6-grpc-doc-dev
Architecture: all
Section: libdevel
Depends: qt6-base-doc-dev, ${misc:Depends},
Multi-Arch: foreign
Description: Qt 6 gRPC tags files
 Qt is a cross-platform C++ application framework. Qt's primary feature
 is its rich set of widgets that provide standard GUI functionality.
 .
 This package contains the doxygen tags files for the Qt gRPC documentation.

Package: qt6-grpc-examples
Architecture: any
Multi-Arch: same
Section: misc
Depends: ${misc:Depends}, ${shlibs:Depends},
Description: Qt 6 gRPC examples
 Qt is a cross-platform C++ application framework. Qt's primary feature
 is its rich set of widgets that provide standard GUI functionality.
 .
 This package contains the examples for the Qt gRPC submodule.

## qt6-grpc 6.8.3

=== tests/CMakeLists.txt ===
# Copyright (C) 2022 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

if(QT_BUILD_STANDALONE_TESTS)
    # Gui is need to build and run tests on Android Platforms.
    find_package(Qt6 ${PROJECT_VERSION} CONFIG REQUIRED COMPONENTS Protobuf Grpc)
    find_package(Qt6 ${PROJECT_VERSION} QUIET CONFIG OPTIONAL_COMPONENTS Gui Quick QuickTest)
    find_package(WrapgRPC QUIET)
endif()
set(QT_BUILD_TESTS_BATCHED FALSE)
qt_build_tests()

=== src/grpcquick/CMakeLists.txt ===
# Copyright (C) 2023 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

qt_internal_add_qml_module(GrpcQuick
    URI QtGrpc
    VERSION ${CMAKE_PROJECT_VERSION}
    PLUGIN_TARGET grpcquickplugin
    CLASS_NAME GrpcQuickPlugin
    SOURCES
        qqmlabstractgrpcchannel.h qqmlabstractgrpcchannel_p.h qqmlabstractgrpcchannel.cpp
        qqmlgrpcnamespace_p.h
        qqmlgrpchttp2channel_p.h qqmlgrpchttp2channel.cpp
        qqmlgrpcchanneloptions_p.h qqmlgrpcchanneloptions.cpp
        qqmlgrpccalloptions.h qqmlgrpccalloptions.cpp
        qqmlgrpcmetadata_p.h qqmlgrpcmetadata.cpp
        qqmlgrpcfunctionalhandlers.h qqmlgrpcfunctionalhandlers.cpp
        qtqmlgrpcstreamsender.h qtqmlgrpcstreamsender.cpp
    LIBRARIES
        Qt::Core
        Qt::Grpc
    PUBLIC_LIBRARIES
        Qt::Quick
    QT_LICENSE_ID QT_COMMERCIAL_OR_GPL3
)

qt_internal_extend_target(GrpcQuick CONDITION QT_FEATURE_qml_ssl
    LIBRARIES
        Qt::QmlNetwork
        Qt::QmlNetworkPrivate
)

=== src/protobufqttypes/CMakeLists.txt ===
# Copyright (C) 2023 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

if(QT_FEATURE_protobuf_qtcoretypes)
    add_subdirectory(protobufqtcoretypes)
endif()

if(TARGET Qt6::Gui AND QT_FEATURE_protobuf_qtguitypes)
    add_subdirectory(protobufqtguitypes)
endif()

=== src/tools/CMakeLists.txt ===
# Copyright (C) 2022 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

qt_internal_skip_sanitizer()

# Skip building qtprotoccommon when not building tools
if((QT_FEATURE_qtprotobufgen OR QT_FEATURE_qtgrpcgen) AND
    TARGET WrapProtobuf::WrapLibProtoc AND TARGET WrapProtobuf::WrapLibProtobuf)
    add_subdirectory(qtprotoccommon)
endif()

if(QT_FEATURE_qtprotobufgen OR
    (QT_HOST_PATH AND Qt6::qtprotobufgen IN_LIST Qt6ProtobufTools_TARGETS
     AND NOT QT_FORCE_BUILD_TOOLS))

    add_subdirectory(qtprotobufgen)
elseif(NOT QT_FEATURE_qtprotobufgen AND QT_FORCE_BUILD_TOOLS)
    # TODO: We ignore the QT_FORCE_BUILD_TOOLS option for this tool to pass the CI check.
    # See QTBUG-110849 for details.
    message(WARNING "You are trying to force build the qtprotobufgen tool, but its dependencies"
        " are missing. The tool build is disabled.")
endif()

if(QT_FEATURE_qtgrpcgen OR
    (QT_HOST_PATH AND Qt6::qtgrpcgen IN_LIST Qt6GrpcTools_TARGETS
     AND NOT QT_FORCE_BUILD_TOOLS))
    add_subdirectory(qtgrpcgen)
elseif(NOT QT_FEATURE_qtprotobufgen AND QT_FORCE_BUILD_TOOLS)
    # TODO: We ignore the QT_FORCE_BUILD_TOOLS option for this tool to pass the CI check.
    # See QTBUG-110849 for details.
    message(WARNING "You are trying to force build the qtgrpcgen tool, but its dependencies"
        " are missing. The tool build is disabled.")
endif()

# Needs to be called at the end after all relevant target have created.
qt_internal_skip_linking_sanitizer()

=== tests/manual/CMakeLists.txt ===
# Copyright (C) 2024 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

add_subdirectory(grpc)

=== examples/grpc/magic8ball/CMakeLists.txt ===
--- 
+++ 
@@ -16,7 +16,6 @@
     ProtobufQuick
     Grpc
     GrpcQuick
-    GrpcTools
     Quick
 )

=== src/tools/qtgrpcgen/CMakeLists.txt ===
# Copyright (C) 2022 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

qt_get_tool_target_name(target_name qtgrpcgen)
qt_internal_add_tool(${target_name}
    TARGET_DESCRIPTION "Qt gRPC generator"
    INSTALL_DIR "${INSTALL_LIBEXECDIR}"
    TOOLS_TARGET Grpc
    CORE_LIBRARY None
    EXCEPTIONS
    SOURCES
        main.cpp
        qgrpcgenerator.cpp qgrpcgenerator.h
        grpctemplates.cpp grpctemplates.h
        serverdeclarationprinter.cpp serverdeclarationprinter.h
        clientdeclarationprinter.cpp clientdeclarationprinter.h
        clientdefinitionprinter.cpp clientdefinitionprinter.h
        qmlclientdeclarationprinter.cpp qmlclientdeclarationprinter.h
        qmlclientdefinitionprinter.cpp qmlclientdefinitionprinter.h
    EXTRA_CMAKE_FILES
        "${CMAKE_CURRENT_SOURCE_DIR}/${QT_CMAKE_EXPORT_NAMESPACE}GrpcToolsMacros.cmake"
    EXTRA_CMAKE_INCLUDES
        "${QT_CMAKE_EXPORT_NAMESPACE}GrpcToolsMacros.cmake"
    LIBRARIES
        WrapProtobuf::WrapLibProtoc
        QtProtocCommon
    ATTRIBUTION_FILE_DIR_PATHS
        ../../../
    ATTRIBUTION_ENTRY_INDEX 1
)

qt_internal_return_unless_building_tools()

qt_record_extra_package_dependency(${target_name} WrapProtoc "")

if(MSVC)
    # Disable C4251:
    # `class 'type1' needs to have dll-interface to be used by clients of class 'type2'`
    # which can be generated from some of the protobuf headers on msvc.
    # This warning is also disabled globally in Qt in QtCore/qcompilerdetection.h
    target_compile_options(${target_name}
        PRIVATE "/wd4251"
    )
    target_compile_definitions(${target_name}
        PRIVATE "_SILENCE_CXX17_ITERATOR_BASE_CLASS_DEPRECATION_WARNING"
    )
endif()

=== src/tools/qtprotoccommon/CMakeLists.txt ===
# Copyright (C) 2022 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

qt_add_library(QtProtocCommon STATIC
    qtprotocdefs.h
    baseprinter.cpp baseprinter.h
    descriptorprinterbase.h
    generatorbase.cpp generatorbase.h
    generatorcommon.cpp generatorcommon.h
    options.cpp options.h
    commontemplates.cpp commontemplates.h
    utils.cpp utils.h
)

target_link_libraries(QtProtocCommon
    PUBLIC
        WrapProtobuf::WrapLibProtobuf
        WrapProtobuf::WrapLibProtoc
)

target_include_directories(QtProtocCommon PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
)

=== tests/auto/grpcgen/CMakeLists.txt ===
# Copyright (C) 2022 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

if(NOT QT_BUILD_STANDALONE_TESTS AND NOT QT_BUILDING_QT)
    cmake_minimum_required(VERSION 3.16)
    project(tst_qtgrpcgen LANGUAGES CXX)
    find_package(Qt6BuildInternals REQUIRED COMPONENTS STANDALONE_TEST)
    include("${CMAKE_CURRENT_LIST_DIR}/../protocplugintestcommon/CMakeLists.txt")
endif()

set(cmake_generated_dir "cmake_generated")
qt_internal_add_test(tst_qtgrpcgen
    SOURCES
        tst_qtgrpcgen.cpp
    LIBRARIES
        Qt::Test
        Qt::Protobuf
        Qt::Grpc
        protocplugintestcommon
    DEFINES
        PROTOC_EXECUTABLE="$<TARGET_FILE:WrapProtoc::WrapProtoc>"
        PROTOC_PLUGIN="$<TARGET_FILE:Qt6::qtgrpcgen>"
        CMAKE_GENERATED_DIR="${cmake_generated_dir}"
        BINARY_DIR="${CMAKE_CURRENT_BINARY_DIR}"
)

qt_add_protobuf(tst_qtgrpcgen_protobuf_common
    OUTPUT_DIRECTORY
        "${CMAKE_CURRENT_BINARY_DIR}/${cmake_generated_dir}/protobuf_common"
    GENERATE_PACKAGE_SUBFOLDERS
    PROTO_FILES
        data/qtgrpcgen.proto
)

set(cmake_generator_tests "")
qt_add_grpc(tst_qtgrpcgen_generate_package_subfolders CLIENT
    PROTO_FILES
        data/qtgrpcgen.proto
    GENERATE_PACKAGE_SUBFOLDERS
    OUTPUT_DIRECTORY
        "${CMAKE_CURRENT_BINARY_DIR}/${cmake_generated_dir}/generate_package_subfolders"
)
target_link_libraries(tst_qtgrpcgen_generate_package_subfolders
    PRIVATE tst_qtgrpcgen_protobuf_common)
list(APPEND cmake_generator_tests generate_package_subfolders)

qt_add_grpc(tst_qtgrpcgen_no_options CLIENT
    PROTO_FILES
        data/qtgrpcgen.proto
    OUTPUT_DIRECTORY
        "${CMAKE_CURRENT_BINARY_DIR}/${cmake_generated_dir}/no_options"
)
target_link_libraries(tst_qtgrpcgen_no_options
    PRIVATE tst_qtgrpcgen_protobuf_common)
target_include_directories(tst_qtgrpcgen_no_options PRIVATE
    "${CMAKE_CURRENT_BINARY_DIR}/${cmake_generated_dir}/protobuf_common/qtgrpc/tests")
list(APPEND cmake_generator_tests no_options)

qt_add_protobuf(tst_qtgrpcgen_protobuf_invalid-identifier
    PROTO_FILES
        data/666-invalid-identifier.proto
    OUTPUT_DIRECTORY
        "${CMAKE_CURRENT_BINARY_DIR}/${cmake_generated_dir}/invalid-identifier"
)
qt_add_grpc(tst_qtgrpcgen_invalid-identifier CLIENT
    PROTO_FILES
        data/666-invalid-identifier.proto
    OUTPUT_DIRECTORY
        "${CMAKE_CURRENT_BINARY_DIR}/${cmake_generated_dir}/invalid-identifier"
)
target_link_libraries(tst_qtgrpcgen_invalid-identifier
    PRIVATE tst_qtgrpcgen_protobuf_invalid-identifier)
list(APPEND cmake_generator_tests invalid-identifier)

if(TARGET Qt6::GrpcQuick)
    qt_internal_extend_target(tst_qtgrpcgen
        DEFINES
            HAVE_QML
    )

    qt_add_protobuf(tst_qtgrpcgen_qml
        PROTO_FILES
            data/qtgrpcgen.proto
        QML
        OUTPUT_DIRECTORY
            "${CMAKE_CURRENT_BINARY_DIR}/${cmake_generated_dir}/qml"
    )

    qt_add_grpc(tst_qtgrpcgen_qml CLIENT
        PROTO_FILES
            data/qtgrpcgen.proto
        QML
        OUTPUT_DIRECTORY
            "${CMAKE_CURRENT_BINARY_DIR}/${cmake_generated_dir}/qml"
    )
    list(APPEND cmake_generator_tests qml)
endif()

foreach(test_name IN LISTS cmake_generator_tests)
    set(target tst_qtgrpcgen_${test_name})
    qt_autogen_tools_initial_setup(${target})
    get_target_property(qml_plugin_target ${target} QT_QML_MODULE_PLUGIN_TARGET)
    if(TARGET ${qml_plugin_target})
        qt_autogen_tools_initial_setup(${qml_plugin_target})
    endif()
    add_dependencies(tst_qtgrpcgen ${target})
endforeach()

list(JOIN cmake_generator_tests "," cmake_generator_tests_string)
qt_internal_extend_target(tst_qtgrpcgen
    DEFINES
        CMAKE_GENERATOR_TESTS="${cmake_generator_tests_string}"
)

=== tests/auto/protobufqml/CMakeLists.txt ===
# Copyright (C) 2023 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

add_subdirectory(basic)
add_subdirectory(enums)
add_subdirectory(nopackage)
add_subdirectory(syntax)
add_subdirectory(nested)
add_subdirectory(messagelists)
add_subdirectory(oneof)

=== tests/benchmarks/protobuf/CMakeLists.txt ===
# Copyright (C) 2024 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

add_subdirectory(deserialize)

=== examples/grpc/chat/client/CMakeLists.txt ===
# Copyright (C) 2023 The Qt Company Ltd.
# SPDX-License-Identifier: LicenseRef-Qt-Commercial OR BSD-3-Clause

cmake_minimum_required(VERSION 3.18)
project(qtgrpc_chat_client LANGUAGES CXX)

if(NOT DEFINED INSTALL_EXAMPLESDIR)
    set(INSTALL_EXAMPLESDIR "examples")
endif()
set(INSTALL_EXAMPLEDIR "${INSTALL_EXAMPLESDIR}/grpc/chat")

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

option(GRPC_CHAT_USE_EMOJI_FONT "Enable emoji font support" OFF)

find_package(Qt6 REQUIRED
    COMPONENTS
        Core
        Gui
        Qml
        Quick
        QuickControls2
        Protobuf
        ProtobufQtCoreTypes
        ProtobufQuick
        Grpc
        GrpcQuick
)
qt_standard_project_setup(REQUIRES 6.8)

qt_add_executable(qtgrpc_chat_client WIN32 MACOSX_BUNDLE main.cpp)
qt_add_qml_module(qtgrpc_chat_client
    URI QtGrpcChat
    VERSION 1.0
    QML_FILES
        Main.qml
        ChatView.qml
        LoginView.qml
        StatusDisplay.qml
        ChatMessages/FileContinuationDelegate.qml
        ChatMessages/FileDelegate.qml
        ChatMessages/ImageDelegate.qml
        ChatMessages/TextDelegate.qml
        ChatMessages/UserStatusDelegate.qml
    RESOURCES
        res/send.svg
        res/generic_file.svg
        res/attach.svg
    SOURCES
        chatengine.h chatengine.cpp
        clientworker.h clientworker.cpp
        userstatusmodel.h userstatusmodel.cpp
        chatmessagemodel.h chatmessagemodel.cpp
)

qt_add_resources(qtgrpc_chat_client "resources"
    FILES
        res/root.crt
        res/qtchat_logo.png
)

if(GRPC_CHAT_USE_EMOJI_FONT)
    set(font_path "${CMAKE_CURRENT_BINARY_DIR}/downloads/NotoColorEmoji.ttf")

    if(NOT EXISTS "${font_path}")
        file(MAKE_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/downloads")
        set(font_url "https://github.com/googlefonts/noto-emoji/raw/main/fonts/NotoColorEmoji.ttf")
        file(DOWNLOAD ${font_url} ${font_path} SHOW_PROGRESS)
    endif()

    set_source_files_properties(${font_path} PROPERTIES QT_RESOURCE_ALIAS "NotoColorEmoji.ttf")
    qt_add_resources(qtgrpc_chat_client "font"
        FILES
            "${font_path}"
    )
    target_compile_definitions(qtgrpc_chat_client PRIVATE USE_EMOJI_FONT)
endif()

#! [client-setup-1]
add_library(qtgrpc_chat_client_proto STATIC)
qt_add_protobuf(qtgrpc_chat_client_proto
    QML
    QML_URI QtGrpcChat.Proto
    PROTO_FILES
        ../proto/chatmessages.proto
    PROTO_INCLUDES
        $<TARGET_PROPERTY:Qt6::ProtobufQtCoreTypes,QT_PROTO_INCLUDES>
)

qt_add_grpc(qtgrpc_chat_client_proto CLIENT
    PROTO_FILES
        ../proto/qtgrpcchat.proto
    PROTO_INCLUDES
        $<TARGET_PROPERTY:Qt6::ProtobufQtCoreTypes,QT_PROTO_INCLUDES>
)
#! [client-setup-1]

if(ANDROID)
    set_target_properties(qtgrpc_chat_client
        PROPERTIES
            QT_ANDROID_PACKAGE_SOURCE_DIR "${CMAKE_CURRENT_LIST_DIR}/android"
            QT_ANDROID_PACKAGE_NAME "org.qtproject.grpc.chat"
            QT_ANDROID_APP_NAME "QtGrpcChat"
            QT_ANDROID_APP_ICON "@drawable/icon"
    )

    include(FetchContent)
    FetchContent_Declare(
        android_openssl
        DOWNLOAD_EXTRACT_TIMESTAMP true
        URL https://github.com/KDAB/android_openssl/archive/refs/heads/master.zip
    )
    FetchContent_MakeAvailable(android_openssl)
    include(${android_openssl_SOURCE_DIR}/android_openssl.cmake)
    add_android_openssl_libraries(qtgrpc_chat_client)
endif()

#! [client-setup-2]
target_link_libraries(qtgrpc_chat_client_proto
    PUBLIC
        Qt6::Protobuf
        Qt6::ProtobufQtCoreTypes
        Qt6::Grpc
)
#! [client-setup-2]

target_link_libraries(qtgrpc_chat_client
    PRIVATE
        Qt6::Core
        Qt6::Gui
        Qt6::Qml
        qtgrpc_chat_client_proto
)

install(TARGETS qtgrpc_chat_client
    RUNTIME DESTINATION "${INSTALL_EXAMPLEDIR}"
    BUNDLE DESTINATION "${INSTALL_EXAMPLEDIR}"
    LIBRARY DESTINATION "${INSTALL_EXAMPLEDIR}"
)

qt_generate_deploy_qml_app_script(
    TARGET qtgrpc_chat_client
    OUTPUT_SCRIPT deploy_script
    MACOS_BUNDLE_POST_BUILD
    NO_UNSUPPORTED_PLATFORM_ERROR
    DEPLOY_USER_QML_MODULES_ON_UNSUPPORTED_PLATFORM
)
install(SCRIPT ${deploy_script})

if(TARGET qtgrpc_chat_server)
    add_dependencies(qtgrpc_chat_client qtgrpc_chat_server)
endif()

=== debian/changelog ===
qt6-grpc (6.8.3-0ubuntu1) plucky; urgency=medium

  * New upstream release (LP: #2103945).

 -- Simon Quigley <tsimonq2@ubuntu.com>  Thu, 27 Mar 2025 22:25:24 -0500

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: qt6-grpc
 Section: libs
 Priority: optional
-Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
 Uploaders: Patrick Franz <deltaone@debian.org>,
 Build-Depends: cmake (>= 3.24~),
                debhelper-compat (= 13),
@@ -15,10 +16,10 @@
                pkg-kde-tools,
                pkgconf,
                protobuf-compiler-grpc,
-               qt6-base-dev (>= 6.8.2+dfsg~),
-               qt6-base-private-dev (>= 6.8.2+dfsg~),
-               qt6-declarative-dev (>= 6.8.2+dfsg~),
-               qt6-declarative-private-dev (>= 6.8.2+dfsg~),
+               qt6-base-dev (>= 6.8.3+dfsg~),
+               qt6-base-private-dev (>= 6.8.3+dfsg~),
+               qt6-declarative-dev (>= 6.8.3+dfsg~),
+               qt6-declarative-private-dev (>= 6.8.3+dfsg~),
 Build-Depends-Indep: qt6-base-dev (>= 6.8~) <!nodoc>,
                      qt6-documentation-tools (>= 6.8~) <!nodoc>,
 Standards-Version: 4.7.0

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk

export DEB_BUILD_MAINT_OPTIONS = hardening=+all optimize=+lto

# cross-builds
ifneq ($(DEB_BUILD_ARCH),$(DEB_HOST_ARCH))
	extra_cmake_args += -DQT_HOST_PATH=/usr
endif

%:
	dh $@ --buildsystem=cmake+ninja

override_dh_auto_configure:
	dh_auto_configure -- \
		--log-level=STATUS \
		-DCMAKE_LIBRARY_PATH=$(DEB_HOST_MULTIARCH) \
		$(extra_cmake_args)

override_dh_auto_build-indep:
	dh_auto_build -- docs

override_dh_auto_install-indep:
	DESTDIR=$(CURDIR)/debian/tmp dh_auto_build -- install_docs
	# Remove build path from index files.
	find $(CURDIR)/debian/tmp/usr/share/qt6/doc -type f -name *.index -exec \
               sed -i 's@$(CURDIR)/@@g' {} \;

execute_after_dh_auto_install-arch:
	# Reproducible builds: remove build paths from .prl files
	sed -i -e '/^QMAKE_PRL_BUILD_DIR/d' debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/libQt6*.prl
